<?php
namespace Teknisa\DF\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Row;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Teknisa\DF\Services\Ger80909GrupoProdutoConsultoriaService;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Ger80909GrupoProdutoConsultoriaController extends \Teknisa\DF\Controllers\TeknisaCrud {
    
    protected $entityManager;
    protected $parameterBagColumns; 
    protected $crudService;
    protected $service;
     
    public function __construct($crudService, $parameterBag, Ger80909GrupoProdutoConsultoriaService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function saveCenarioGrupo(Request $request, Response $response){
        $row = $request->getRow();
        
        $cenarios = $this->service->getArrayCenario($row);
        
        $this->dataSourceName = 'cenariogrup';
        
        $dataSetCenario = new DataSet('cenariogrup', $cenarios);
        $requestCenario = new Request\DataSet($dataSetCenario, $request->getMethod(),$request->getRoutePath(), $request->getUserId());
        
        parent::save($requestCenario, $response);
    }
    
    public function saveProdutoGrupoCons(Request $request, Response $response) {
        $this->dataSourceName = 'itgrupprodcon';
        parent::save($request, $response);
    }
    
    public function atualizarRegraGrupo(Request $request, Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        foreach($rows as $row) {
            $this->service->atualizarRegraGrupo($row);
        }
    }
    
    public function findProdcutsConsultoria(Request $request, Response $response) {
        $filter = $request->getFilterCriteria();
        $conditions = $filter->getConditions();
 
        $this->dataSourceName = 'produto_consultoria';
        
        $newConditions = array();
        foreach($conditions as &$condition) {
            if($condition["operator"] == "MAPPED_LIKE_ALL" || $condition["operator"] == "LIKE_ALL") {
                if(gettype($condition["value"]) == "array") {
                    if(substr($condition["value"][0]["_ALL"], 0, 1) == '%') {
                        $condition["value"][0]["_ALL"] = substr($condition["value"][0]["_ALL"], 1);
                        if($condition["value"]) {
                            $newConditions[] = $condition;
                        }
                    }
                    else {
                        if($condition["value"] && $condition["value"] != '%' && $condition["value"] != "%%") {
                            $newConditions[] = $condition;
                        }
                    }
                }
                else {
                    if($condition["value"] && $condition["value"] != "%" && $condition["value"] != "%%") {
                        $newConditions[] = $condition;
                    }
                }
            }
            else {
                if($condition["value"] && $condition["value"] != "%" && $condition["value"] != "%%") {
                    $newConditions[] = $condition;
                }
            }
        }

        $filterCriteria = new FilterCriteria('produto_consultoria', $newConditions, $filter->getPage(), $filter->getPageSize());

        $request = new Request\Filter($filterCriteria, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
        parent::find($request, $response);
    }
    
    public function zerarPonteiroAtualizacao(Request $request, Response $response) {
        $this->service->zerarPonteiroAtualizacao();
    }
    
}